#!/usr/bin/perl --


use CGI;
use CGI::Carp "fatalsToBrowser";

###########################################################################################
## Default header for the perl files. Sets important variables, initiates the text output, and loads prasi settings.
## THIS FILE ** MUST ** be included in **ALL** perl scripts from wefis!!
###########################################################################################
$Wefis_Version = "1.5";
print "Content-type: text/html; charset=ISO-8859-1\n\n";
$u=prasi_login("${SERVICE_NAME}",1);
select_lang();
($aquot)=prasi_data($u,"${SERVICE_NAME}_quota");
($homedir)=prasi_data($u,"${SERVICE_NAME}_home_directory");
($baseurl)=prasi_data($u,"${SERVICE_NAME}_home_url");
($iconset)=prasi_data($u,"${SERVICE_NAME}_home_icons");
($penabled)=prasi_data($u,"${SERVICE_NAME}_plugins_enabled");		#Create an index html file for each new directory created?
($m_toolbar)=prasi_data($u,"${SERVICE_NAME}_minimised_toolbar");
($compatupload)=prasi_data($u,"${SERVICE_NAME}_compatibility_upload");
($wefis_guest)=prasi_data($u,"${SERVICE_NAME}_guest_user");
($indexfile)=prasi_data($u,"${SERVICE_NAME}_index_file");		#Create an index html file for each new directory created?
chomp($aquot);chomp($homedir);chomp($baseurl);chomp($iconset);chomp($penabled);chomp($indexfile);
chomp($m_toolbar);chomp($wefis_guest);chomp($compatupload);
if(!$homedir and !$baseurl and !$aquot) {do_wefis_142_update_fix();}
if(!$homedir or !$baseurl or !$aquot) {complain_invalid_prasi_settings();}
if(!$iconset) {$iconset="default";}
$total_size = 0;
count_all(""); # after homedir def
$aquot_kb = sprintf "%.2f", $aquot * 1024.0;
$uquot_kb = sprintf "%.2f", ${total_size}/1024.0;
$uquot = sprintf "%.2f", $total_size/1024.0/1024.0 ; # get mb
$percent = sprintf "%.0f", $uquot*100/$aquot ; # all mb
$DOC_ROOT="$homedir";
$DOC_URL="$baseurl";
$DOC_URL =~ s/\/$//g;
$DOC_ROOT =~ s/\/$//g;
if(!-e "${THEME_ROOT_PATH}/${iconset}/icons.js") {inform_theme_generation();}	#Check the theme is available!
###########################################################################################


#This forces the theme to be generated, thus avoiding errors due to no icons, and missing js functions.
sub inform_theme_generation {
	print "<CENTER><BR><BR><TABLE width=\"500\"><TR><TD><IMG SRC=\"./themes.cgi?icon=help\" BORDER=0></TD><TD>";
	print "${TRANS_information_}<BR><B>${TRANS_your_theme_files_have_been_updated}.</B><BR>${TRANS_please_reload_wefis} ";
	print "<A HREF=\"\">${TRANS_here}</A>.";
	print "</TD></TR></TABLE><BR></CENTER>";
	exit;
}

#This is a 'fix' for missing data in wefis..!
sub complain_invalid_prasi_settings {
	error("Invalid prasi settings!");	#for the moment!
}

#This is a 'fix' for the update from 1.4.1 to 1.4.2 where the stored data format was slightly altered under certain circumstances to allow encapsulation...
sub do_wefis_142_update_fix {
	($aquot)=prasi_data($u,"wefis_quota");
	($homedir)=prasi_data($u,"wefis_home_directory");
	($baseurl)=prasi_data($u,"wefis_home_url");
	($iconset)=prasi_data($u,"wefis_home_icons");
	chomp($aquot);
	chomp($homedir);
	chomp($baseurl);
	chomp($iconset);
	prasi_save($u,"${SERVICE_NAME}_quota",$aquot,$SERVICE_NAME);
	prasi_save($u,"${SERVICE_NAME}_home_directory",$homedir,$SERVICE_NAME);
	prasi_save($u,"${SERVICE_NAME}_home_url",$baseurl,$SERVICE_NAME);
	prasi_save($u,"${SERVICE_NAME}_home_icons",$iconset,$SERVICE_NAME);
	
	print "<DIV name=\"update_profile_info\" id=\"update_profile_info\"><TABLE width=\"500\"><TR><TD><IMG SRC=\"${THEME_ROOT}/themes.cgi?icon=ok\" BORDER=0 /></TD><TD>";
	print "Your user profile has been updated from a WEFIS 1.4.0 to 1.4.2 system. This allows a user to be part of multiple installations of wefis, and avoids cross-data writing. All data has been transfered, and everything should continue working as before...<BR><A HREF=\"#\" onclick=\"changeDiv('update_profile_info','hidden');\">${TRANS_close}</A>";
	print "</TD></TR></TABLE><BR></DIV>";
}

sub checkDirExists {
	my ($dir) = @_;
	$dir =~ s/\/+/\//g;			#remove double /'s...
	$dir = clean_path($dir);
	my $p='';
	@bits = split(/\//, $dir);
	foreach $item (@bits) {
		$p = clean_path("$p$item/");
		if(!-e $p) {mkdir $p;chmod oct("0777"), "$p";}
		if(!-e $p) {sleep 5;}		#Directory may not have been created yet!!
		if(!-e $p) {print "${TRANS_could_not_create_the_target_directory__}<BR>$p";exit;}
	}
	if(!-e $dir) {mkdir $dir;chmod oct("0777"), "$dir";}
	if(!-e $dir) {sleep 5;}		#Directory may not have been created yet!!
	if(!-e $dir) {print "${TRANS_could_not_create_the_requested_directory__permission_denied_}<BR>$dir";exit;}
}

sub checkSystem {
	(my $what) = @_;
	$what =~ s/[<>&|^]/_/g;		#remove certain characters...
	return $what;
}

sub count_all { # count total size of user files
	my ($add) = @_;
	my $list_dir = "${homedir}$add";
	my @files;
	my $fitem;
	if (opendir(DIR,"$list_dir") == 1) {
		@files = readdir(DIR);
		closedir(DIR);
	} else {
		error("${TRANS_cannot_read_folder} '$list_dir'.");
	}
	foreach $fitem (@files) {
		$fitem_pathname = "$list_dir" . "/" . "$fitem";
		if (-e $fitem_pathname) {
			if (-d $fitem_pathname) {
				#if($fitem=~/\.\./) {next;}
				#if($fitem=~/\./) {next;}
				if($fitem eq ".") {next;}
				if($fitem eq "..") {next;}
				count_all("$add/$fitem");
			} else {
				$file_size = -s $fitem_pathname ;
				$total_size = $total_size + $file_size ;
			}
		}
	}
}

sub file_perm {
	($file2) = @_;
	$mode = "";
	($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime, $mtime, $ctime, $blksize, $blocks) = stat($file2);
	$perm = "";
	if($mode & 0400) {$perm .= "r";}
	else {$perm .= "-";}
	if($mode & 0200) {$perm .= "w";}
	else {$perm .= "-";}
	if($mode & 0100) {$perm .= "x";}
	else {$perm .= "-";}
	if($mode & 040) {$perm .= "r";}
	else {$perm .= "-";}
	if($mode & 020) {$perm .= "w";}
	else {$perm .= "-";}
	if($mode & 010) {$perm .= "x";}
	else {$perm .= "-";}
	if($mode & 004) {$perm .= "r";}
	else {$perm .= "-";}
	if($mode & 002) {$perm .= "w";}
	else {$perm .= "-";}
	if($mode & 001) {$perm .= "x";}
	else {$perm .= "-";}
	print "$perm ";
	$str = sprintf "(%04o)",$mode & 07777;
	print $str;
}

sub nice_date {
	(my $date) = @_;
	($sec, $min, $hr, $day, $month, $year, $day_Of_Week, $julianDate, $dst) = localtime($date); 
	$month+=1;
	$year+=1900;
	($sec2, $min2, $hr2, $day2, $month2, $year2, $day_Of_Week2, $julianDate2, $dst2) = localtime(); 
	$month2+=1;
	$year2+=1900;
	
	if($julianDate2==$julianDate and $year==$year2) {	#same day...
		if($hr==$hr2) {print "<I>${TRANS_a_few_moments_ago}</I>";}
		elsif(($hr2-$hr)==1) {print "<I>${TRANS_an_hour_ago}</I>";}
		elsif(($hr2-$hr)==2) {print "<I>${TRANS_two_hours_ago}</I>";}
		elsif(($hr2-$hr)==3) {print "<I>${TRANS_three_hours_ago}</I>";}
		else {print "<I>${TRANS_today}</I>";}
	}
	elsif($julianDate2==($julianDate+1) and $year==$year2) {print "<I>${TRANS_yesterday}</I>";}
	elsif(($julianDate2-$julianDate)<=2 and $year==$year2) {print "<I>${TRANS_two_days_ago}</I>";}
	elsif(($julianDate2-$julianDate)<=5 and $year==$year2) {print "<I>${TRANS_this_week}</I>";}
	else {print "$day/$month/$year";}
}

sub file_stats {
	($fufile) = @_;
	($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime, $mtime, $ctime, $blksize, $blocks) = stat($fufile);
	nice_date($ctime);
	print "|";
	nice_date($mtime);
	print "|";
	nice_date($atime);
	print "|";
}


sub find_exts { # find all extensions... !!NOW UNUSED!!!
	my $list_dir = "./img/icons";
	my @files;
	my $fitem;
	if (opendir(DIR,"$list_dir") == 1) {
		@files = readdir(DIR);
		closedir(DIR);
	} else {
		error("${TRANS_cannot_read_folder} '$list_dir'.");
	}
	foreach $fitem (@files) {
		$fitem_pathname = "$list_dir" . "/" . "$fitem";
		if (-e $fitem_pathname) {
			if (!-d $fitem_pathname) {
				my @bits = split(/\./, $fitem);
				my $ext = pop(@bits);
				$ext = pop(@bits);
				print "$ext|";
			}
		}
	}
}

sub find_themes { # find all existing themes on the system...
	my $list_dir = "${THEME_ROOT_PATH}";
	my @files;
	my $fitem;
	if (opendir(DIR,"$list_dir") == 1) {
		@files = readdir(DIR);
		closedir(DIR);
	} else {
		error("${TRANS_cannot_read_folder} '$list_dir'.");
	}
	foreach $fitem (@files) {
		if ($fitem eq ".") {next;}
		if ($fitem eq "..") {next;}
		if(-d "$list_dir/$fitem") {print "$fitem|";}
	}
}


sub list_plugins { # find all plugins installed for multimode...
	my $list_dir = "./plugins";
	if(!-e $list_dir) {return;}
	my @files;
	my $fitem;
	if (opendir(DIR,"$list_dir") == 1) {
		@files = readdir(DIR);
		closedir(DIR);
	} else {
		error("${TRANS_cannot_read_folder} '$list_dir'.");
	}
	foreach $fitem (@files) {
		$fitem_pathname = "$list_dir"."/"."$fitem";
		if (-e $fitem_pathname) {
			if (!-d $fitem_pathname) {
				if($fitem_pathname =~ m/\.multi$/ig) {
					$plugin_action = "init";
					if(require "$fitem_pathname") {
						if($plugin_name && $plugin_descr) {print "$plugin_descr,$plugin_name|";}
					}
				}
			}
		}
	}
}

sub list_help_docs { # find all plugins installed for multimode...
	my $list_dir = "./docs";
	if(!-e $list_dir) {error("${TRANS_the_docments_help_folder_does_not_exist__wefis_has_probably_been_badly_configured___}");}
	my @files;
	my $fitem;
	if (opendir(DIR,"$list_dir") == 1) {
		@files = readdir(DIR);
		closedir(DIR);
	} else {
		error("${TRANS_cannot_read_folder} '$list_dir'.");
	}
	@files = sort @files;
	print "<TABLE WIDTH=600>";
	foreach $fitem (@files) {
		$fitem_pathname = "$list_dir"."/"."$fitem";
		if (-e $fitem_pathname) {
			if (!-d $fitem_pathname) {
				if($fitem_pathname =~ m/\.html$/ig) {		#ALL help items are html pages!
					print "<TR><TD width=\"20\%\"><IMG SRC=\"./themes.cgi?icon=help\" border=0></TD>";
					print "<TD><A HREF=\"./action.cgi?action=openhelp&param=$fitem\" target=\"_new\">$fitem</A></TD></TR>\n";
				}
			}
		}
	}
	print "</TABLE><BR><B>${TRANS_programmed_by}</B> Franois Botman, 2006<BR><B>${TRANS_kindly_translated_by}</B> ${TRANSLATION_AUTHOR}<BR><B>${TRANS_current_theme_created_by}</B>: <SPAN id=\"theme_aut\">fetching...</SPAN><BR><B>${TRANS_with_support_from}</B> <A HREF=\"http://wefis.sf.net\">SOURCEFORGE.NET</A><BR><BR><I>${TRANS_wefis_version_} $Wefis_Version<BR></I><BR>";
}

sub ListFav {
	($favcnt)=prasi_data($u,"${SERVICE_NAME}_FAVITEMCNT");
	if(!$favcnt) {$favcnt=0;}
	chomp($favcnt);

	my $favcntvar = 0;
	while($favcntvar < $favcnt) {
		($favitem)=prasi_data($u,"${SERVICE_NAME}_FAVITEM_$favcntvar");
		chomp($favitem);
		print "$favitem|";
		$favcntvar++;
	}
}

sub list_raw_data {
	my ($add) = @_;
	my $list_dir = "${homedir}$add";
	my @dfiles;
	my $fitem;
	if(!$add) {		#Add root!! ;-)
		print "/|directory|";
		file_stats($list_dir);
		file_perm($list_dir);
		print "|$total_size\n";
	}
	if (opendir(DIR,"$list_dir") == 1) {
		@dfiles = readdir(DIR);
		closedir(DIR);
	} else {error("${TRANS_cannot_read_folder} '$list_dir'.");}
	
	my @files = sort @dfiles;		# <------ This line makes everything in order or not! believe it or not, it does actually do a lot, presentation-wise!!
	foreach $fitem (@files) {
		$fitem_pathname = "$list_dir" . "/" . "$fitem";
		$fitem_psname = "$add"."/"."$fitem";
		if (-e $fitem_pathname) {
			if (-d $fitem_pathname) {
				if ($fitem eq ".") {next;}
				if ($fitem eq "..") {next;}
				print "$fitem_psname/|directory|";
				file_stats($fitem_pathname);
				file_perm($fitem_pathname);
				$file_size = -s $fitem_pathname ;
				print "|$file_size\n";
				
				list_raw_data("$add/$fitem");
			} else {
				@bits = split(/\./, $fitem);
				$ext = pop(@bits);
				print "$fitem_psname|$ext|";
				file_stats($fitem_pathname);
				file_perm($fitem_pathname);
				$file_size = -s $fitem_pathname ;
				print "|$file_size\n";
			}
		}
	}
}

sub delete_dirs {
	(my $root) = @_;
	my @files;
	my $fitem;
	if (opendir(DIR,"$root") == 1) {
		@files = readdir(DIR);
		closedir(DIR);
	} else {error("${TRANS_cannot_read_folder} '$root'.");}
	@files = sort @files;
	foreach $fitem (@files) {
		my $fitem_pathname = clean_path("$root"."/"."$fitem");
		if ($fitem eq ".") {next;}
		if ($fitem eq "..") {next;}
		if (-e $fitem_pathname) {
			if (!-d $fitem_pathname) {
				if(!unlink "$fitem_pathname") {print "${TRANS_could_not_delete_the_requested_file__permission_denied_}<BR>$fitem_pathname";exit;}
			}
			else {
				delete_dirs($fitem_pathname);		#recursive delete!!
				if(!rmdir "$fitem_pathname") {
					print "${TRANS_could_not_delete_the_requested_directory__permission_denied_}<BR>$fitem_pathname";
					exit;
				}
			}
		}
	}
}

sub clean_path{
	# This function is a crucial part of our security!
	# If this fails then any internal user can potentially overwrite any file on the system (slightly exagerate)...
	($test) = @_;
	# collapse expanded tree:
	$test =~ s/[^\/]*\/\.\.//g;
	# get rid of any spurious (dangerous) '..'s:
	$test =~ s/\.\.//g;
	# remove multiple '/'s left over:
	$test =~ s/\/+/\//g;
	# That first regexp gives navigation: if we append '../' then we *can* move upwards. 
	# The next regexp removes any remaining '../' which would result in our going higher than allowed. 
	# The last regexp simply tidies things up a bit.
	# But, is this the best way of doing it?
	return "$test";
}

sub checkPath {
	(my $path) = @_;
	$path = clean_path($path);	#remove all ../...
	return clean_path("${DOC_ROOT}/$path");	
}



sub select_lang {
	(my $lang) = prasi_data($u,"language");
	chomp($lang);
	if(!$lang) {$lang = "english";}
	if($lang eq "default") {$lang = "english";}			#Wefis defaults to english!!
	if(-e "./lang/$lang.pl") {$js_file_loc = "_$lang.js";require "./lang/$lang.pl";}
	else {		#default to english
		if($ALLOW_PRINT_LANGUAGE_WARNING) {print "<B>!! Language \"$lang\" is not yet available in WEFIS...<BR>If you are interested in translating this tool to other languages, please contact us at sourceforge.<BR><B>Defaulting to english!!</B><BR><BR>";}
		$js_file_loc = "_english.js";
		require "./lang/english.pl";
	}	
}

sub error {
	($mesg)=@_;
	print "<TABLE width=\"500\"><TR><TD><IMG SRC=\"./themes.cgi?icon=warn\" BORDER=0></TD><TD>";
	print "${TRANS_the_following_error_occurred_}<BR><B>$mesg</B><BR>${TRANS_cannot_continue_}";
	print "</TD></TR></TABLE><BR><CENTER></CENTER>";
	print "<SCRIPT>busy();</SCRIPT>";
	exit;
}


sub preview {
	(my $file) = @_;
	@bits = split(/\./, $file);
	$ext = lc(pop(@bits));
	if((-e "./plugins/$ext.ext") and ($penabled eq "true")) {
		$plugin_file = checkPath($file);
		if(do "./plugins/$ext.ext") {print "<OK>";}
	}
	else {
		$prevw = "${TRANS_no_preview_available_for_this_type_of_file_}";
		if($file =~ /\.(jpg|gif|png|bmp|tiff)$/i) {
			my $sss = 0;
			$sss = -s "${DOC_ROOT}$file";
			if($sss < 6000) { # if less than 6kB
				$prevw = "[${TRANS_small_} $sss]<br><img src=\"${DOC_URL}$location$file\">";
			} else {
				$prevw = "[${TRANS_large_} $sss]<br><img src=\"${DOC_URL}$location$file\" width=200>";
			}
		}
		$linecnt=0;
		if($file =~ /\.(html|shtml|htm|xml)$/i) {
			$prevw = "<IFRAME src=\"${DOC_URL}$file\" Border=\"0\" WIDTH=\"200\" Height=\"400\"></IFRAME>";
		}
		if($file =~ /\.(txt|inf|dat|pl|cgi|bak|tex|css|c|h|cpp|java)$/i) {
			$prevw = "<hr>";
			open(IN,"< $file");
			for ($cntr=1; $cntr<512; $cntr++) {
				my $char = getc IN; 
				if($char eq "\n") {$char="<br>";} else {$char =~ s/[^\w-\s]/\./gi;} #replace HTML by dot.
				$linecnt++;
				if($linecnt eq "30") {$linecnt=0;$prevw .= "<BR>";}		#max column width... change values here!
				$prevw .= "$char";
			}
			close(IN);
			$prevw .= "<br>...<hr>";
		}
		if($file =~ /\.(mus)$/i) {
			$prevw = "<embed src=\"${DOC_URL}$file\" width=200 height=300 type=\"application/x-myriad-music\" align=center LOOK=OCEAN pluginspage=\"http://www.myriad-online.com/cgi-bin/mmplug.pl\"></embed>";
		}
		if($file =~ /\.(wav|mp3|mid|mp2|ogg|wma)$/i) {
			$prevw = "<EMBED SRC=\"${DOC_URL}$file\" WIDTH=200 AUTOSTART=TRUE>";
		}
		print $prevw;
	}
}

sub checkFullQuota {
	$total_size = 0;
	count_all("");		#get actual usage...
	if($total_size>($aquot*1024*1024)) {fullquota("$aquot_kb");exit;}
}

sub fullquota {   # quota exceeded
($allowed_kb) = @_;
print "
${TRANS__b_error__b____your_quota__the_maximum_amount_of_disk_space_you_can_use__has_been_set_by_the__prasi_administrator_to_} $allowed_kb ${TRANS_kb__the_operation_which_you_attempted_to_carry_out_would__have_carried_you_over_this_limit_and_has_hence_been__b_cancelled__b___br__it_is_recommended_t}
";
print "<SCRIPT>busy();</SCRIPT>";
#exit;   # we have to prevent the upload.
}

sub ascii_mode {
($w)=@_;
# the following IS safe since we know $w is a real file!
print `perl ./dos2unix.pl "$w"`;
print "<BR>";
}

return 1;
