/********************************************************************************************
	Secondary Javascript file for Wefis 1.4
	Written in April 2006
	This file is an integral part of Wefis, and code herein is licensed under GPL.
	If you use code in these files, please keep the following lines in the code:
	
	Programmed by Franois Botman for Wefis (http://wefis.sf.net).
	If you find bugs, please report them here: franchie@users.sourceforge.net
***********************************************************************************************/

/**********************************************************************************************
	Other.js; contains all the functions to manage diverse activity not covered by the other files...
	Dependancies; ajax.js, main.js
**********************************************************************************************/



var colours="#117CA1 #16A0CF #2FB9E9 #F77121 #F7CD21 #F9D852 #FBE383";
var cols = colours.split(" ");
var cnt=Math.round(Math.random()*(cols.length-1));
var onehtml='';
var angle = 0;

function makeDiv(x, y, w, h,col,txt)
{
	/*col can be this.color*/
	onehtml += '<div style="position: absolute;'+
		'left:' + x + 'px;'+
		'top:' + y + 'px;'+
		'background-color:' + col + ';">'+txt+'<\/div>';
}
function roundedRect(ctx,x,y,width,height,radius){
	ctx.beginPath();
	ctx.moveTo(x,y+radius);
	ctx.lineTo(x,y+height-radius);
	ctx.quadraticCurveTo(x,y+height,x+radius,y+height);
	ctx.lineTo(x+width-radius,y+height);
	ctx.quadraticCurveTo(x+width,y+height,x+width,y+height-radius);
	ctx.lineTo(x+width,y+radius);
	ctx.quadraticCurveTo(x+width,y,x+width-radius,y);
	ctx.lineTo(x+radius,y);
	ctx.quadraticCurveTo(x,y,x,y+radius);
	ctx.stroke();
}

function setupcanvas(f,w,h) {
	f.lineWidth = 1;
	f.clearRect(0,0,w,h); 				// clear canvas
	//roundedRect(f,5,5,w-10,h-10,15);
}
function drawCircle(canvas,x,y,w,h,frac,label,displaced) {
	if(((2*Math.PI*frac)-angle)==0) return;		//avoid stupid errors...
	var lang = angle + ((2*Math.PI*frac)-angle)/2;
	var f = canvas.getContext('2d');			//only 2D supported so far!!
	if(angle==0) setupcanvas(f,w,h);
	f.fillStyle = cols[cnt];
	var xx=w/2,yy=h/2,R = Math.min(w/2 - 30,h/2 - 30);
	if(displaced) {
		xx+=Math.cos(lang)*20;
		yy+=Math.sin(lang)*20;
	}

	f.save();
	f.beginPath();
	f.moveTo(xx,yy);
	f.lineTo(xx,yy);
	f.arc(xx,yy,R,angle,Math.PI*2*frac,false);
	f.lineTo(xx,yy);
	f.fill();
	f.restore();

	//add label?
	xx=w/2+Math.cos(lang)*R;
	yy=h/2+Math.sin(lang)*R;
	if(displaced) {
		xx+=Math.cos(lang)*20;
		yy+=Math.sin(lang)*20;
	}
	if(((2*Math.PI*frac)-angle)>0.2) makeDiv(xx+x,yy+y,10,20,'transparent;border: thin grey','<LI>'+label);

	cnt+=1;
	if(cnt>=cols.length) cnt=0;
	angle = Math.PI*2*frac;
}

function graphit(plot,div,explode) {
	var cnt2 = cnt;
	var canvas = document.getElementById('cvs');
	if (!canvas.getContext) {writeDiv('one','');return;}
	var one = document.getElementById(div);
	if(!one) {alert('object not found...');return;}
	var html='';
	var h = canvas.innerHeight ? canvas.innerHeight : canvas.clientHeight;
	var w = canvas.innerWidth ?canvas.innerWidth : canvas.clientWidth;
	var bits = plot.split('#');
	angle = 0;
	var totvalue = 0;
	var q;
	for(i=0;i<bits.length;i++) {
		q = bits[i].split('|');
		totvalue+=parseInt(q[1]);
	}
	var value=0;
	for(i=0;i<bits.length;i++) {
		q = bits[i].split('|');
		var label = q[0];
		value += parseInt(q[1]);
		if(parseInt(q[1])!=0) {
			if(explode=='true' || q[2]!='0') drawCircle(canvas,document.getElementById('canvascontainer').style.left,document.getElementById('canvascontainer').style.top-10,w,h,(value/totvalue),label,1);
			else drawCircle(canvas,document.getElementById('canvascontainer').style.left,document.getElementById('canvascontainer').style.top-10,w,h,(value/totvalue),label,0);
		}
	}
	writeDiv('one',onehtml);
	onehtml='';
	cnt = cnt2;		//reset colours to make things look ok...
}


function plotstats(explode) {
	var plt=''
	var i=0;
	angle=0;
	while(document.getElementById('exp'+i)) {
		if(plt!='') plt+='#';
		var p1 = ElementValue('label'+i);
		var p2 = ElementValue('value'+i);
		var p3 = ElementValue('exp'+i);
		if(!p1) p1='0';
		if(!p2) p2='0';
		if(!p3) p3='0';

		plt+=p1+'|'+p2+'|'+p3;
		i++;
	}
	graphit(plt,'one',explode);
}

function doTableStats(howmany) {
	if(!howmany || howmany<0) howmany=5;
	var html='<DIV align="right">';
	if(howmany>5) html+='<A HREF="javascript:doTableStats('+(howmany-5)+');">[Fewer]</A> | ';
	html+='<A HREF="javascript:doTableStats('+(howmany+5)+');">[More]</A>';
	html+='</DIV><TABLE width=600><TR><TD><B>Filename</B></TD><TD><B>Size</B></TD></TR>';
	var d = getData('raw').split('\n');
	var max=0;
	for(var i=0;i<howmany;i++) {
		var localmax=0;
		var max_name='';
		for(var t=0;t<d.length;t++) {
			var s = d[t].split('|');
			if(s[6]>localmax && ((s[6]<max || max==0) && s[1]!='directory')) {
				localmax = parseInt(s[6]);
				max_name = s[0];
			}
		}
		if(localmax>0 && max_name) {
			max=localmax;
			html+='<TR onClick="browseTo(\''+max_name+'/../'+'\',getFileName(\''+max_name+'\'));" onMouseOver="this.style.backgroundColor=\'#F5F5F5\';document.getElementById(\'exp'+i+'\').value = 1 - document.getElementById(\'exp'+i+'\').value;plotstats();" onMouseOut="this.style.backgroundColor=\'#FFFFFF\';document.getElementById(\'exp'+i+'\').value = 1 - document.getElementById(\'exp'+i+'\').value;plotstats()"><TD>'+max_name;
			html+='<INPUT TYPE=hidden id="exp'+i+'" name="exp'+i+'" value=""><INPUT TYPE=hidden name="label'+i+'" id="label'+i+'" value="'+getFileName(max_name)+'"><INPUT TYPE=hidden name="value'+i+'" id="value'+i+'" value="'+max+'"></TD><TD>';
			if(max>(1024*1024)) html+=Math.round((max/(1024*1024)),2)+' Mb.</TD></TR>';
			else if(max>1024) html+=Math.round((max/1024))+' kb.</TD></TR>';
			else html+=max+' b.</TD></TR>';
		}
	}
	html+='</TABLE>';
	/*<DIV id="canvascontainer" name="canvascontainer"><CANVAS id="cvs" name="cvs" width=300 height=300>Your browser does not support canvases... Please get a more modern browser, such as FireFox, if you want to see the graphs produced...</CANVAS><BR><DIV id="one" name="one">[Labels are loading...]</DIV></DIV>*/
	writeDiv('statstable',html);
	plotstats();
}

/*Show the filespace statistics...*/
function showStats() {
	clearLeft();
	changeDiv('cvs','visible');
	changeDiv('canvascontainer','visible');
	changeDiv('one','visible');
	
	var html='<H1>Statistics...</H1>';
	var l = (parseInt(getData('quota_used'))/parseInt(getData('quota')))*400;
	html+=idletext+':<BR><DIV style="position:relative;width:400px;height:10px;background-color: #F5F5F5;border: thin solid gray;"><DIV style="position:relative; width:'+l+'px;height:10px;background-color:red;"></DIV></DIV><BR><BR>';
	html+='<H2>Largest files:</H2><BR>';
	
	html+='<DIV name="statstable" id="statstable">[loading...]</DIV><BR><BR>';
	html+='<CENTER><A HREF="javascript:browseTo();">Close</A></CENTER>';
	writeDiv('list',html);
	doTableStats();
}