#!/usr/bin/perl

require "./lang-default.pl";
require "./config.pl";
require "./layout.pl";
       BEGIN {
          eval {
            require Digest::MD5;
            import Digest::MD5 'md5_hex'
          };
          if ($@) { # ups, no Digest::MD5
            require Digest::Perl::MD5;
            import Digest::Perl::MD5 'md5_hex'
          }             
        }

package PRASI;  # fully scoped

# functions whose name start with underscore are defunct

sub print_service_list {
(my $u) = @_;
my $a="";
if (opendir(DIR,"$PRASI::datatree/users/$u") == 1) {
      @files = readdir(DIR);
      closedir(DIR);
   }
   else {
    die("$PRASI::lang::msg70 '$u'.");
   }
   my @tfiles = sort @files;
   my $fitem = "";
   foreach $fitem (@tfiles) {
      my $fitem_pathname = "$PRASI::datatree/users/$u" . "/" . "$fitem";
      if (-e $fitem_pathname) {
         if (-d $fitem_pathname) {next;}
         if ($fitem =~ /(.*)\.svc/) {
            my $s = $1;
            (my $n,my $v,my $c,my $r) = service_info($s);
            print "<li><a href=\"$r\">$n</a>";
            }
		 if ($fitem =~ /(.*)\.rsvc/) {
            my $s = $1;
            (my $n,my $v,my $c,my $r,my $dom,my $sc,my $q) = remote_service_info($s);
            print "<li><a href=\"$r\">$n ($dom)</a>";
            }
      }
   }
}

sub user_services {
(my $u) = @_;
my $a="";
if (opendir(DIR,"$PRASI::datatree/users/$u") == 1) {
      @files = readdir(DIR);
      closedir(DIR);
   }
   else {
    die("$PRASI::lang::msg70 '$u'.");
   }
   my @tfiles = sort @files;
   my $fitem = "";
   foreach $fitem (@tfiles) {
      $fitem_pathname = "$PRASI::datatree/users/$u" . "/" . "$fitem";
      if (-e $fitem_pathname) {
         if (-d $fitem_pathname) {next;}
         if ($fitem =~ /(.*)\.svc/) {
            my $p = $1;
            (my $n,my $v,my $c,my $r) = service_info($p);
            print "$n ";
            }
      }
   }
}

sub select_lang {
if (opendir(DIR,"$PRASI::langpath") == 1) {
      @files = readdir(DIR);
      closedir(DIR);
   }
   else {
    print "<option value=\"english\">English (default)</option>";
	return;
   }
   my @tfiles = sort @files;
   my $fitem = "";
   foreach $fitem (@tfiles) {
      $fitem_pathname = "$PRASI::langpath" . "/" . "$fitem";
      if (-e $fitem_pathname) {
         if (-d $fitem_pathname) {next;}
         if ($fitem =~ /lang-(.*)\.pl/) {
            my $p = $1;
            print "<option value=\"$p\">$p</option>";
            }
      }
   }
}

sub _print_manager_table {
my $a="";
if (opendir(DIR,"$PRASI::datatree/services") == 1) {
      @files = readdir(DIR);
      closedir(DIR);
   }
   else {
    die("$PRASI::lang::msg71");
   }
   my @tfiles = sort @files;

# first the header

   print "<table border=1><tr><td>$PRASI::lang::msg84a</td>";
   my $fitem = "";
   foreach $fitem (@tfiles) {
      my $fitem_pathname = "$PRASI::datatree/services" . "/" . "$fitem";
      if (-e $fitem_pathname) {
         if (-d $fitem_pathname) {next;}
         if ($fitem =~ /(.*)\.cfg/) {
            my $s = $1;
            (my $n,my $v,my $c,my $r) = service_info($s);
	    $n =~ s/\_/\<br\>/gi;
            print "<td><a href=\"$r\">$n</a></td>";
            }
      }
   }

# then the users loop and within that loop over services
  print "<td></td></tr>";
  if (opendir(DIR,"$PRASI::datatree/users") == 1) {
      @ufiles = readdir(DIR);
      closedir(DIR);
   }
   else { die("$PRASI::lang::msg71"); }
   my @utfiles = sort @ufiles;
   my $ufitem = "";
   foreach $ufitem (@utfiles) {
      my $ufitem_pathname = "$PRASI::datatree/users" . "/" . "$ufitem";
      if (-e $ufitem_pathname) {
         if (-d $ufitem_pathname) {
         if($ufitem eq ".") {next;}
         if($ufitem eq "..") {next;}
            my $s = $ufitem;
            print "<tr><td>$s</td>";

   #inner loop of services
   foreach $fitem (@tfiles) {
      my $fitem_pathname = "$PRASI::datatree/services" . "/" . "$fitem";
      if (-e $fitem_pathname) {
         if (-d $fitem_pathname) {next;}
         if ($fitem =~ /(.*)\.cfg/) {
            my $ccv = $1;
            if(-e "$PRASI::datatree/users/$s/$ccv.svc") {
print "
<td bgcolor=\"green\">
<form action=\"manage.cgi\" method=\"post\">
<input type=submit value=\"-\">
<input type=hidden name=target value=\"$s\">
<input type=hidden name=service value=\"$ccv\">
<input type=hidden name=action value=\"delservice\"></form>
</td>
";
} else {
print "
<td bgcolor=\"red\">
<form action=\"manage.cgi\" method=\"post\">
<input type=submit value=\"+\">
<input type=hidden name=target value=\"$s\">
<input type=hidden name=service value=\"$ccv\">
<input type=hidden name=action value=\"addservice\"></form>
</td>
";
}
            }
      }
   }
	# resume outer loop
            print "<td><a href=\"manage.cgi?target=$s&action=deluser\" onclick=\"javascript:return confirm('$PRASI::lang::msg142')\">$PRASI::lang::msg72</a></td></tr>";
            }
      }
   }

  print "</table>";
}

sub print_manager_table_combined {
my $a="";
if (opendir(DIR,"$PRASI::datatree/services") == 1) {
      @files = readdir(DIR);
      closedir(DIR);
   }
   else {
    die("$PRASI::lang::msg71");
   }
   my @tfiles = sort @files;

# first the header

   print "<table border=0><tr><td>$PRASI::lang::msg84a</td>";
   my $fitem = "";
   foreach $fitem (@tfiles) {
      my $fitem_pathname = "$PRASI::datatree/services" . "/" . "$fitem";
      if (-e $fitem_pathname) {
         if (-d $fitem_pathname) {next;}
         if ($fitem =~ /(.*)\.cfg/) {
            my $s = $1;
            (my $n,my $v,my $c,my $r) = service_info($s);
	    $n =~ s/\_/\<br\>/gi;
            print "<td><a href=\"$r\">$n</a><br>(version $v)</td>";
            }
      }
   }

if (opendir(DIR,"$PRASI::datatree/remote-services") == 1) {
      @rfiles = readdir(DIR);
      closedir(DIR);
   }
   else {
    die("$PRASI::lang::msg71r");
   }
   my @rtfiles = sort @rfiles;

   my $fitem = "";
   foreach $rfitem (@rtfiles) {
      my $rfitem_pathname = "$PRASI::datatree/remote-services" . "/" . "$rfitem";
      if (-e $rfitem_pathname) {
         if (-d $rfitem_pathname) {next;}
         if ($rfitem =~ /(.*)\.cfg/) {
            my $s = $1;
            (my $n,my $v,my $c,my $r,my $dom,my $sc,my $q) = remote_service_info($s);
	    $n =~ s/\_/\<br\>/gi;
            print "<td><a href=\"$r\">$n</a><br>(version $v)<br>($dom)</td>";
            }
      }
   }

# then the users loop and within that loop over services
  print "<td></td></tr>";
  if (opendir(DIR,"$PRASI::datatree/users") == 1) {
      @ufiles = readdir(DIR);
      closedir(DIR);
   }
   else { die("$PRASI::lang::msg71"); }
   my @utfiles = sort @ufiles;
   my $ufitem = "";
   foreach $ufitem (@utfiles) {
      my $ufitem_pathname = "$PRASI::datatree/users" . "/" . "$ufitem";
      if (-e $ufitem_pathname) {
         if (-d $ufitem_pathname) {
         if($ufitem eq ".") {next;}
         if($ufitem eq "..") {next;}
            my $s = $ufitem;
            print "<tr><td>$s</td>";

   #inner loop of services
   foreach $fitem (@tfiles) {
      my $fitem_pathname = "$PRASI::datatree/services" . "/" . "$fitem";
      if (-e $fitem_pathname) {
         if (-d $fitem_pathname) {next;}
         if ($fitem =~ /(.*)\.cfg/) {
            my $ccv = $1;
            if(-e "$PRASI::datatree/users/$s/$ccv.svc") {
print "
<td bgcolor=\"green\">
<form action=\"manage.cgi\" method=\"post\">
<input type=submit value=\"-\">
<input type=hidden name=target value=\"$s\">
<input type=hidden name=service value=\"$ccv\">
<input type=hidden name=action value=\"delservice\"></form>
</td>
";
} else {
print "
<td bgcolor=\"red\">
<form action=\"manage.cgi\" method=\"post\">
<input type=submit value=\"+\">
<input type=hidden name=target value=\"$s\">
<input type=hidden name=service value=\"$ccv\">
<input type=hidden name=action value=\"addservice\"></form>
</td>
";
}
            }
      }
   }

   foreach $rfitem (@rtfiles) {
      my $rfitem_pathname = "$PRASI::datatree/remote-services" . "/" . "$rfitem";
      if (-e $rfitem_pathname) {
         if (-d $rfitem_pathname) {next;}
         if ($rfitem =~ /(.*)\.cfg/) {
            my $ccv = $1;
            if(-e "$PRASI::datatree/users/$s/$ccv.rsvc") {
print "
<td bgcolor=\"green\">
<form action=\"manage.cgi\" method=\"post\">
<input type=submit value=\"-\">
<input type=hidden name=target value=\"$s\">
<input type=hidden name=service value=\"$ccv\">
<input type=hidden name=action value=\"delremservice\"></form>
</td>
";
} else {
print "
<td bgcolor=\"red\">
<form action=\"manage.cgi\" method=\"post\">
<input type=submit value=\"+\">
<input type=hidden name=target value=\"$s\">
<input type=hidden name=service value=\"$ccv\">
<input type=hidden name=action value=\"addremservice\"></form>
</td>
";
}

            }
      }
   }
	# resume outer loop
            print "<td><a href=\"manage.cgi?target=$s&action=deluser\" onclick=\"javascript:return confirm('$PRASI::lang::msg142')\">$PRASI::lang::msg72</a></td></tr>";
            }
      }
   }

  print "</table>";
}

sub _print_manager_table_remote {
my $a="";
if (opendir(DIR,"$PRASI::datatree/remote-services") == 1) {
      @files = readdir(DIR);
      closedir(DIR);
   }
   else {
    die("$PRASI::lang::msg71r");
   }
   my @tfiles = sort @files;

# first the header

   print "<table border=1><tr><td>$PRASI::lang::msg84a</td>";
   my $fitem = "";
   foreach $fitem (@tfiles) {
      my $fitem_pathname = "$PRASI::datatree/remote-services" . "/" . "$fitem";
      if (-e $fitem_pathname) {
         if (-d $fitem_pathname) {next;}
         if ($fitem =~ /(.*)\.cfg/) {
            my $s = $1;
            (my $n,my $v,my $c,my $r,my $dom,my $sc,my $q) = remote_service_info($s);
	    $n =~ s/\_/\<br\>/gi;
            print "<td><a href=\"$r\">$n</a><br>($dom)</td>";
            }
      }
   }

# then the users loop and within that loop over services
  print "<td></td></tr>";
  if (opendir(DIR,"$PRASI::datatree/users") == 1) {
      @ufiles = readdir(DIR);
      closedir(DIR);
   }
   else { die("$PRASI::lang::msg71r"); }
   my @utfiles = sort @ufiles;
   my $ufitem = "";
   foreach $ufitem (@utfiles) {
      my $ufitem_pathname = "$PRASI::datatree/users" . "/" . "$ufitem";
      if (-e $ufitem_pathname) {
         if (-d $ufitem_pathname) {
         if($ufitem eq ".") {next;}
         if($ufitem eq "..") {next;}
            my $s = $ufitem;
            print "<tr><td>$s</td>";

   #inner loop of services
   foreach $fitem (@tfiles) {
      my $fitem_pathname = "$PRASI::datatree/remote-services" . "/" . "$fitem";
      if (-e $fitem_pathname) {
         if (-d $fitem_pathname) {next;}
         if ($fitem =~ /(.*)\.cfg/) {
            my $ccv = $1;
            if(-e "$PRASI::datatree/users/$s/$ccv.rsvc") {
print "
<td bgcolor=\"green\">
<form action=\"manage.cgi\" method=\"post\">
<input type=submit value=\"-\">
<input type=hidden name=target value=\"$s\">
<input type=hidden name=service value=\"$ccv\">
<input type=hidden name=action value=\"delremservice\"></form>
</td>
";
} else {
print "
<td bgcolor=\"red\">
<form action=\"manage.cgi\" method=\"post\">
<input type=submit value=\"+\">
<input type=hidden name=target value=\"$s\">
<input type=hidden name=service value=\"$ccv\">
<input type=hidden name=action value=\"addremservice\"></form>
</td>
";
}
            }
      }
   }
	# resume outer loop
            print "<td><a href=\"manage.cgi?target=$s&action=deluser\"  onclick=\"javascript:return confirm('$PRASI::lang::msg142')\">$PRASI::lang::msg72</a></td></tr>";
            }
      }
   }

  print "</table>";
}


sub print_service_fulllist {
if (opendir(DIR,"$PRASI::datatree/services") == 1) {
      @files = readdir(DIR);
      closedir(DIR);
   }
   else {
    die("$PRASI::lang::msg71");
   }
   my @tfiles = sort @files;
   my $fitem = "";
   foreach $fitem (@tfiles) {
      my $fitem_pathname = "$PRASI::datatree/services" . "/" . "$fitem";
      if (-e $fitem_pathname) {
         if (-d $fitem_pathname) {next;}
         if ($fitem =~ /(.*)\.cfg/) {
            my $s = $1;
            (my $n,my $v,my $c,my $r) = service_info($s);
            print "<li><a href=\"$r\">$n</a></b> ($PRASI::lang::msg73 $v)<b>";
            }
      }
   }
   if (opendir(DIR,"$PRASI::datatree/remote-services") == 1) {
      @files = readdir(DIR);
      closedir(DIR);
   }
   else {
    die("$PRASI::lang::msg71");
   }
   my @tfiles = sort @files;
   my $fitem = "";
   foreach $fitem (@tfiles) {
      my $fitem_pathname = "$PRASI::datatree/remote-services" . "/" . "$fitem";
      if (-e $fitem_pathname) {
         if (-d $fitem_pathname) {next;}
         if ($fitem =~ /(.*)\.cfg/) {
            my $s = $1;
            (my $n,my $v,my $c,my $r,my $dom, my $sc, my $q) = remote_service_info($s);
            print "<li><a href=\"$r\">$n</a></b> (domain $dom; $PRASI::lang::msg73 $v)<b>";
            }
      }
   }
}

sub _print_user_fulllist {  # never called from anywhere, consider deleting
my $a="";
if (opendir(DIR,"$PRASI::datatree/users") == 1) {
      @ufiles = readdir(DIR);
      closedir(DIR);
   }
   else {
    die("$PRASI::lang::msg71");
   }
   my @utfiles = sort @ufiles;
   my $ufitem = "";
   foreach $ufitem (@utfiles) {
      my $ufitem_pathname = "$PRASI::datatree/users" . "/" . "$ufitem";
      if (-e $ufitem_pathname) {
         if (-d $ufitem_pathname) {
         if($ufitem eq ".") {next;}
         if($ufitem eq "..") {next;}
            my $s = $ufitem;
            print "<li>$s - (";
            user_services($s);
            print ")  
<form action=\"manage.cgi\" method=\"post\">
<input type=submit value=\"$PRASI::lang::msg74 '$s'\">
<input type=hidden name=target value=\"$s\">
<input type=hidden name=action value=\"deluser\"  onclick=\"javascript:return confirm('$PRASI::lang::msg142')\"></form>

<form action=\"manage.cgi\" method=\"post\">
<input type=submit value=\"$PRASI::lang::msg75a '$s' $PRASI::lang::msg75b\">
<input type=hidden name=target value=\"$s\">
<input type=text name=service>
<input type=hidden name=action value=\"addservice\"></form>

<form action=\"manage.cgi\" method=\"post\">
<input type=submit value=\"$PRASI::lang::msg76a '$s' $PRASI::lang::msg76b\">
<input type=hidden name=target value=\"$s\">
<input type=text name=service>
<input type=hidden name=action value=\"delservice\"></form>
            ";
            }
      }
   }
}

sub check_service_defaults {
(my $u,my $n) = @_;
pretty_page();
print "<b>$PRASI::lang::msg77a '$u' $PRASI::lang::msg77b '$n':</b><br><br>
<form action=\"manage.cgi\" method=\"post\">
<input type=hidden name=target value=\"$u\">
";
my $path = "$PRASI::datatree/services/$n.cfg";
open(IN,$path) || die "$PRASI::lang::msg78 '$n'";
my @lines = <IN>;
close(IN);
my $k="";
my $line = "";
foreach $line (@lines) {
 if($line =~ /default:(.*)/) {
 my $var=$1;
 chomp($var);
 chomp($var);
 (my $con) = prasi_data($u,$var);
 chomp($con);
 if($con eq "") {$con = get_suggestion($var,@lines);}
 print "
 $var: <input type=text name=\"$var\" value=\"$con\"><br>
 ";
 $k .= $var;
 $k .= "*";
 }
}
print "
<input type=hidden name=vars value=\"$k\">
<input type=hidden name=closewindow value=\"$closewindow\">
<input type=submit value=\"$PRASI::lang::msg79\">
<input type=hidden name=action value=\"cfgservice\"></form>
";
exit;
}

sub check_remote_service_defaults {
(my $u,my $n) = @_;
pretty_page();
print "<b>$PRASI::lang::msg77a '$u' $PRASI::lang::msg77b '$n':</b><br><br>
<form action=\"manage.cgi\" method=\"post\">
<input type=hidden name=target value=\"$u\">
";
my $path = "$PRASI::datatree/remote-services/$n.cfg";
open(IN,$path) || die "$PRASI::lang::msg78 '$n'";
my @lines = <IN>;
close(IN);
my $k="";
my $line = "";
foreach $line (@lines) {
 if($line =~ /default:(.*)/) {
 my $var=$1;
 chomp($var);
 chomp($var);
 (my $con) = prasi_data($u,$var);
 chomp($con);
 if($con eq "") {$con = get_suggestion($var,@lines);}
 print "
 $var: <input type=text name=\"$var\" value=\"$con\"><br>
 ";
 $k .= $var;
 $k .= "*";
 }
}
print "
<input type=hidden name=vars value=\"$k\">
<input type=submit value=\"$PRASI::lang::msg79\">
<input type=hidden name=closewindow value=\"$closewindow\">
<input type=hidden name=action value=\"cfgservice\"></form>
";
exit;
}

sub fullcheck_service_requires {
(my $u,my $n) = @_;
pretty_page();
print "$u$PRASI::lang::msg80a '$n' $PRASI::lang::msg80b<br><br>
<form action=\"login.cgi\" method=\"post\">
";
my $path = "$PRASI::datatree/services/$n.cfg";
open(IN,$path) || die "$PRASI::lang::msg78 '$n'";
my @lines = <IN>;
close(IN);
my $k="";
my $line = "";
foreach $line (@lines) {
 if($line =~ /require:(.*)/) {
 my $var=$1;
 chomp($var);
 chomp($var);
 (my $con) = prasi_data($u,$var);
 chomp($con);
 if($con eq "") {$con = get_suggestion($var,@lines);}
 print "
 $var: <input type=text name=\"$var\" value=\"$con\"><br>
 ";
 $k .= $var;
 $k .= "+";
 }
}
print "
<input type=hidden name=vars value=\"$k\">
<input type=hidden name=requires value=\"$n\">
<input type=submit value=\"$PRASI::lang::msg81\">
<input type=hidden name=action value=\"chk2\"></form>
";
exit;
}

sub service_info {
(my $q) = @_;
my $name='';
my $vers='';
my $contact='';
my $url='';
my $path = "$PRASI::datatree/services/$q.cfg";
open(IN,$path) || die "$PRASI::lang::msg78 '$q'";
my @lines = <IN>;
close(IN);
my $line = "";
foreach $line (@lines) {
 if($line =~ /service:name:(.*)/) {$name=$1;next;}
 if($line =~ /service:version:(.*)/) {$vers=$1;next;}
 if($line =~ /service:contact:(.*)/) {$contact=$1;next;}
 if($line =~ /service:url:(.*)/) {$url=$1;next;}
}
return ($name,$vers,$contact,$url);
}

sub remote_service_info {
(my $q) = @_;
my $name='';
my $vers='';
my $contact='';
my $url='';
my $domain='';
my $scode='';
my $path = "$PRASI::datatree/remote-services/$q.cfg";
open(IN,$path) || die "$PRASI::lang::msg78r '$q'";
my @lines = <IN>;
close(IN);
my $line = "";
foreach $line (@lines) {
 if($line =~ /service:name:(.*)/) {$name=$1;next;}
 if($line =~ /service:version:(.*)/) {$vers=$1;next;}
 if($line =~ /service:contact:(.*)/) {$contact=$1;next;}
 if($line =~ /service:url:(.*)/) {$url=$1;next;}
 if($line =~ /service:gateway:(.*)/) {$gate=$1;next;}
 if($line =~ /service:domain:(.*)/) {$domain=$1;next;}
 if($line =~ /service:code:(.*)/) {$scode=$1;next;}
}
return ($name,$vers,$contact,$url,$domain,$scode,$gate);
}

sub get_suggestion {
(my $var,my @lines)=@_;
my $inli = "";
foreach $inli (@lines) {
 if($inli =~ /suggest:${var}:(.*)/) {return $1;}
}
return "";
}

sub set_remote_cookies {
(my $user,my $passexp) = @_;
# foreach remote service the user has access to
# read the values and call the remote-prasi-client to set the cookie
# do this via an img-include tag.
# then this routine will print "Cookie for xxxxxx set OK\n" after each image
# note we should only proceed with the javascript redirect once all cookies have been set!
if (opendir(DIR,"$PRASI::datatree/users/$user") == 1) {
      @files = readdir(DIR);
      closedir(DIR);
   }
   else {
    die("$PRASI::lang::msg70 $user");
   }
   my @tfiles = sort @files;
   my $fitem = "";
   foreach $fitem (@tfiles) {
      my $fitem_pathname = "$PRASI::datatree/users/$user" . "/" . "$fitem";
      if (-e $fitem_pathname) {
         if (-d $fitem_pathname) {next;}
         if ($fitem =~ /(.*)\.rsvc/) {
            my $s = $1;
            (my $n,my $v,my $c,my $r,my $dom,my $sc,my $q) = remote_service_info($s);
			my $tobehashed = "$sc$passexp"; # . $ENV{'REMOTE_ADDR'};
			my $thehash = main::md5_hex($tobehashed);
			my $qu = rando();
            print "
			<img src=\"$q?action=setcookie&query=$qu&value=$user:$thehash\" width=1 height=1 border=0>
			$PRASI::lang::msg137a $s $PRASI::lang::msg137b\n<br>";
        }
      }
   }
}

sub remote_login_response {
  ($u) = @_;
  if(!$u) {print "void";exit;}
  my $r = user_expiry($u);
  print "$r";
  exit;
}

sub user_expiry {
 my ($who) = @_;
 my $nn="";
 my $u="";
 my $s="";
 open(IN,"< $PRASI::datatree/prasi_sessions.dat");
 my @li = <IN>;
 close(IN);
 my $ll="";
 foreach $ll (@li) {
 if($ll=~/(.*):(.*):(.*)/) {
  my $tim = $3;
  my $u=$2;
  my $s=$1;
  if ($u eq $who) { # this user
   # return the expiry number
   return $tim;
   } else {
    # someone else
   }
  } else {
  #  badly formatted entry
  }
 }
return "void";
}

sub rando {   # generate a new password (soon migrate generate_pw() to this function)
my $password_length = 5;
my $ret = "";
my @chars = split(" ",
 "a b c d e f g h i j k l m n o p q r s t u v w x y z 
  A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
  0 1 2 3 4 5 6 7 8 9");

srand (time ^ $$ ^ unpack "%L*", `/bin/ps axww | /bin/gzip`);
for ($i=0; $i <= $password_length ;$i++) {
    my $_rand = int(rand 62);
    $ret .= $chars[$_rand];
}
return $ret;
}

return 1;

