#!/usr/bin/perl --

# Prasi component: prasi_installer.cgi
# version 1.4
# copyright botman brothers 2006
# licenced under GPL

# Please report feedback on whether the installation/update process worked for you, and if not, how you fixed it, http://prasi.sourceforge.net

$installversion = "1.4";

use CGI;
use CGI::Carp "fatalsToBrowser";
       BEGIN {
			$installextralibs = "http://prasi.sourceforge.net/extra-libs.tar.gz";
			$p1 = "You do not have the";
			$p2 = "perl library installed. Prasi will not work without it. Please go to";
			$p3 = "and install this library in your Perl path, then re-run this installer. Alternatively you can download <a href=\"$installextralibs\">extra-libs</a> package (and extract it locally), which is a collection of CPAN packages required for Prasi.";
          eval {
            require Digest::MD5;
            import Digest::MD5 'md5_hex'
          };
          if ($@) { # ups, no Digest::MD5
            require Digest::Perl::MD5;
            import Digest::Perl::MD5 'md5_hex'
          }
		  }
		  # determine if some of the more 'unusual' libs are installed
		  eval {require Net::OpenID::Consumer;};
		  if ($@) {print "Content-type: text/html\n\n";print "$p1 Net::OpenID::Consumer $p2 <a href=\"http://search.cpan.org/search?query=Net%3A%3AOpenID%3A%3AConsumer&mode=all\">CPAN</a> $p3";exit;}
		  eval {require Text::Wrap;};
		  if ($@) {print "Content-type: text/html\n\n";print "$p1 Text::Wrap $p2 <a href=\"http://search.cpan.org/search?query=Text%3A%3AWrap&mode=all\">CPAN</a> $p3";exit;}
		  eval {require URI;};
		  if ($@) {print "Content-type: text/html\n\n";print "$p1 URI $p2 <a href=\"http://search.cpan.org/search?query=URI&mode=all\">CPAN</a> $p3";exit;}
		  eval {require URI::Fetch;};
		  if ($@) {print "Content-type: text/html\n\n";print "$p1 URI::Fetch $p2 <a href=\"http://search.cpan.org/search?query=URI%3A%3AFetch&mode=all\">CPAN</a> $p3";exit;}
		  eval {require URI::Fetch::Response;};
		  if($@) {print "Content-type: text/html\n\n";print "$p1 URI::Fetch::Response $p2 <a href=\"http://search.cpan.org/search?query=URI%3A%3AFetch%3AResponse&mode=all\">CPAN</a> $p3";exit;}
		  eval {require Class::ErrorHandler;};
		  if($@) {print "Content-type: text/html\n\n";print "$p1 Class::ErrorHandler $p2 <a href=\"http://search.cpan.org/search?query=Class%3A%3AErrorHandler&mode=all\">CPAN</a> $p3";exit;}
		  eval {require Crypt::DH;};
		  if($@) {print "Content-type: text/html\n\n";print "$p1 Crypt::DH $p2 <a href=\"http://search.cpan.org/search?query=Crypt%3A%3ADH&mode=all\">CPAN</a> $p3";exit;}
		  eval {require Net::OpenID::VerifiedIdentity;};
		  if($@) {print "Content-type: text/html\n\n";print "$p1 Net::OpenID::VerifiedIdentity $p2 <a href=\"http://search.cpan.org/search?query=Net%3A%3AOpenID%3A%3AVerifiedIdentity&mode=all\">CPAN</a> $p3";exit;}
		  eval {require Net::OpenID::ClaimedIdentity;};
		  if($@) {print "Content-type: text/html\n\n";print "$p1 Net::OpenID::ClaimedIdentity $p2 <a href=\"http://search.cpan.org/search?query=Net%3A%3AOpenID%3A%3AClaimedIdentity&mode=all\">CPAN</a> $p3";exit;}
		  eval {require Net::OpenID::Association;};
		  if($@) {print "Content-type: text/html\n\n";print "$p1 Net::OpenID::Association $p2 <a href=\"http://search.cpan.org/search?query=Net%3A%3AOpenID%3A%3AAssociation&mode=all\">CPAN</a> $p3";exit;}


print "Content-type: text/html\n\n";
$f = new CGI;
$step = $f->param('step');
if($step eq "") {$step = "1";}
# for the benefit of Wefis:
$installtype = $f->param('installtype');

print <<"PERLHEAD";
 <STYLE type="text/css">
  #prasi { background-color: #C3D9FF;}
  #code { background-color: lightblue; border-left: solid 3px darkblue; }
 </STYLE>
<center>
<b>Prasi Installer</b><br><br>

<div class="prasi" id ="prasi">
Step $step of 3
</div>
<br>
<br></center>

PERLHEAD

if($step eq "1") {
 print <<"PERLMAIN";
Welcome - you are about to install Prasi on your system. If you have changed your mind about this, 
now would be a good time to close your browser window to abort the installation. This script will 
ask you a few questions, configure Prasi appropriately, then delete itself (for security). Important notes:<ul><li>Have you made a backup of your files? Only proceed if you have done so!<li>Upgrading from Prasi version 1.0 or higher is supported - but lower versions WILL cause problems!</ul><br><br>
<form action="prasi_installer.cgi"><input type=hidden name=step value=2>
<input type=hidden name=installtype value="$installtype">
<input type=submit name=action value="Next step"></form>
PERLMAIN
}
if($step eq "2") {
 $pwd = "$ENV{'SCRIPT_FILENAME'}";
 $pwd =~ s/prasi_installer\.cgi//;
 $server = "$ENV{'SCRIPT_URI'}";
 $server =~ s/prasi_installer\.cgi//;
 print <<"PERLMAIN";
Please answer the following questions:<br><br><form action="prasi_installer.cgi"><input type=hidden name=step value=3>
<input type=hidden name=installtype value="$installtype"><ol>
<hr><li>Where do you want to install Prasi? Note that this might be forced to be in your cgi-bin directory, depending on your system. Please give the full path 
where the script should put the program files: 
<input type=text name=installdir value=$pwd>
<hr><li>What is the full web address of the directory you gave in #1? 
<input type=text name=webdir value="$server">
<hr><li>Where should Prasi keep its data tree? This directory should be inaccessible from the web, to prevent any security risks. Please give the full path: 
<input type=text name=datadir value="">
<hr><li>If you are on a cgi-bin system, certain text and image files cannot be placed in cgi-bin but must be manually installed elsewhere. Please give the full 
web address of the directory where you'll place those files (leave blank if you are not on a cgi-bin system): 
<input type=text name=iconwebpath value="">
<hr><li>Please choose a username for the Prasi administrator (the person who can change Prasi settings, add or remove users, etc): 
<input type=text name=adminuser value="admin">
<hr><li>Please choose a password for the Prasi administrator. Whatever you do, do not forget this; you will have to re-install Prasi from scratch if you do! 
<input type=password name=adminpassword value="">
<hr><li>Please give the email address of this person: 
<input type=text name=adminemail value="$ENV{'SERVER_ADMIN'}">
<hr><li>Please give the server root address (for example, www.example.com), this will be used for the cookie domain extent: 
<input type=text name=server value="$ENV{'SERVER_NAME'}">
<hr><li>Please give the email address from which Prasi can send administrative emails (when notifying users that they have been added to a service, for example): 
<input type=text name=prasiemail value="$ENV{'SERVER_ADMIN'}">
<hr><li>What SMTP server should Prasi use to communicate with the users? 
<input type=text name=sendmaillocation value="$ENV{'SERVER_NAME'}">
<hr><li>Please choose a name for the Prasi cookie. If in doubt, leave this as the default: 
<input type=text name=cookiename value="prasi_authen">
<hr></ol>
<input type=submit value="Next step"></form><br>
(Note that the next page sends many commands to the Operating System and therefore may take a long time to load. 
Whatever you do, it is important that you do not panic. Let the page finish loading before doing anything else.)
PERLMAIN
}
if($step eq "3") {
$installdir = $f->param('installdir');
$installdir=~s/\/$//; # remove trailing '/'
if($installdir eq "") {print "Please go back and fill in ALL the fields...";exit;}
$webdir = $f->param('webdir');
if($webdir eq "") {print "Please go back and fill in ALL the fields...";exit;}
$webdir = $webdir."/" unless ($webdir=~/\/$/); # add trailing '/'
$iconwebpath = $f->param('iconwebpath');
if($iconwebpath eq "") {$iconwebpath="$webdir";exit;}
$iconwebpath = $iconwebpath."/" unless ($iconwebpath=~/\/$/); # add trailing '/'
$datadir = $f->param('datadir');
$datadir=~s/\/$//; # remove trailing '/'
if($datadir eq "") {print "Please go back and fill in ALL the fields...";exit;}
$adminuser = $f->param('adminuser');
if($adminuser eq "") {print "Please go back and fill in ALL the fields...";exit;}
$adminpassword = $f->param('adminpassword');
if($adminpassword eq "") {print "Please go back and fill in ALL the fields...";exit;}
$adminemail = $f->param('adminemail');
if($adminemail eq "") {print "Please go back and fill in ALL the fields...";exit;}
$server = $f->param('server');
if($server eq "") {print "Please go back and fill in ALL the fields...";exit;}
$prasiemail = $f->param('prasiemail');
if($prasiemail eq "") {print "Please go back and fill in ALL the fields...";exit;}
$sendmaillocation = $f->param('sendmaillocation');
if($sendmaillocation eq "") {print "Please go back and fill in ALL the fields...";exit;}
$cookiename = $f->param('cookiename');
if($cookiename eq "") {print "Please go back and fill in ALL the fields...";exit;}
print "Output: (note that some errors are normal and can be ignored, don't panic, but do take note - cut and paste the output somewhere safe for debugging later...)<br><div id=\"code\" class=\"code\"><pre>";


 $prasiemail =~ s/\@/\\\@/;

print "Changed email format to $prasiemail...\n";
print "Creating directories and copying files...\n";

print `mkdir $installdir`;
print `mkdir $datadir`;
#leave the next two lines even if a cgi-bin system, doesn't harm...
print `cp ./prasi_logo.png $installdir/prasi_logo.png`;
print `cp ./openid-inputicon.gif $installdir/openid-inputicon.gif`;
print `cp ./*.pl $installdir/`;
print `cp ./index.html $installdir/index.html`;
print `cp ./*.cgi $installdir/`;
print `cp ./*.txt $installdir/`;

print "Checking if all the required files are findable...\n";

if (-e "$installdir/login.cgi") {
# fine
} else {
 print "*** Error: file login.cgi not found! Your installation will probably fail...\n";
 print "*** Proceeding anyway, but remember to correct this!\n";
}

if (-e "$installdir/upload_service_config_file.cgi") {
# fine
} else {
 print "*** Error: file upload_service_config_file.cgi not found! Your installation will probably fail...\n";
 print "*** Proceeding anyway, but remember to correct this!\n";
}

if (-e "$installdir/manage.cgi") {
# fine
} else {
 print "*** Error: file manage.cgi not found! Your installation will probably fail...\n";
 print "*** Proceeding anyway, but remember to correct this!\n";
}

if (-e "$installdir/internals.pl") {
# fine
} else {
 print "*** Error: file internals.pl not found! Your installation will probably fail...\n";
 print "*** Proceeding anyway, but remember to correct this!\n";
}

if (-e "$installdir/email.pl") {
# fine
} else {
 print "*** Error: file email.pl not found! Your installation will probably fail...\n";
 print "*** Proceeding anyway, but remember to correct this!\n";
}

open(WHERE,">$installdir/prasi.pl") || die "could not open $installdir/prasi.pl";
print WHERE <<"PERLIT";
#!/usr/bin/perl
# See docs for details.

# the next two lines are written by the installer
require "$installdir/lang-default.pl";
require "$installdir/config.pl";

PERLIT
write_prasipl();
close(WHERE);
print "Wrote prasi.pl...\n";

if (-e "$installdir/index.html") {
# fine
} else {
 # this is not compatible with cgi-bin systems
 #print "*** Error: file index.html not found! Your installation will probably fail...\n";
 #print "*** Proceeding anyway, but remember to correct this!\n";
}

if (-e "$installdir/lang-english.pl") {
# fine
} else {
 print "*** Error: no English language file found! You must have at least lang-english.pl installed...\n";
 print "*** Proceeding anyway, but remember to correct this!\n";
}

print `cp $installdir/lang-english.pl $installdir/lang-default.pl`;
print "Set English as your default language... make lang-default.pl point to lang-xxxxx.pl to change this...\n";

open(WHERE,">$installdir/config.pl") || die "could not open $installdir/config.pl";
print WHERE <<"PERLIT";
#!/usr/bin/perl

# in this file, put all amin-editable configuration stuff
# all components should have access to this file
# access from prasi.pl is written to at install-time; others see this locally

package PRASI;

\$PRASI::server = \"$server\";
\$PRASI::from = \"$prasiemail\";
\$PRASI::version = \"$installversion\";

\$PRASI::purl = \"$webdir\";
\$PRASI::pcook = '$cookiename';
\$PRASI::datatree = \"$datadir\";
\$PRASI::langpath = \"$installdir\";
\$PRASI::iconwebpath = \"$iconwebpath\";

# Prasi sends users emails to notify them of certain things. It uses
# the internal Perl SMTP by default. To use an external smtp, replace
# 'internal' by 'external' and give the command's location in ::sendmail.
\$PRASI::smtp = \"internal\";
\$PRASI::sendmail = \"/usr/sbin/sendmail\";
\$PRASI::SMTPServer = \"$sendmaillocation\";

return 1;

PERLIT
close(WHERE);
print "Wrote config.pl...\n";

print `mkdir $datadir/users`;
print `mkdir $datadir/services`;
print `mkdir $datadir/remote-services`;

open(WHERE,">$datadir/services/prasi.cfg") || die "could not open $datadir/services/prasi.cfg";
print WHERE <<"PERLIT";
# Prasi service configuration file
service:name:prasi
service:version:$installversion
service:contact:$adminemail
service:url:$webdir/login.cgi
default:email
PERLIT
close(WHERE);
print "Wrote services/prasi.cfg...\n";

open(WHERE,">$datadir/services/prasi_manager.cfg") || die "could not open $datadir/services/prasi_manager.cfg";
print WHERE <<"PERLIT";
# Prasi service configuration file
service:name:prasi_manager
service:version:$installversion
service:contact:$adminemail
service:url:$webdir/manage.cgi
default:email
PERLIT
close(WHERE);
print "Wrote services/prasi_manager.cfg...\n";

print `chmod -R 755 $installdir`;
print `chmod 755 $installdir/*.cgi`;
print `chmod -R 770 $datadir`;

# UPGRADE BLOCK START
if (-e "$datadir/users/$adminuser/prasi_manager.svc") {
# upgrade
print "Previous Prasi installation detected - no upgrade of admin user!\n";
} else { # fresh install
$pw = main::md5_hex($adminpassword);
print `mkdir $datadir/users/$adminuser`;
print `chmod 770 $datadir/users/$adminuser/`;
open(WHERE,"> $datadir/users/$adminuser/password") || die "could not save admin password!";
print WHERE $pw;
print "Saved admin password...\n";
close(WHERE);
print `chmod 770 $datadir/users/$adminuser/password`;
open(IN,"> $datadir/users/$adminuser/prasi_manager.svc") || die "could not open $datadir/users/$u/prasi_manager.svc";
print IN " ";
print "Configured admin for prasi_manager service...\n";
close(IN);
print `chmod 770 $datadir/users/$adminuser/prasi_manager.svc`;
open(IN,"> $datadir/users/$adminuser/prasi.svc") || die "could not open $datadir/users/$adminuser/prasi.svc";
print IN " ";
print "Configured admin for prasi service...\n";
print `chmod 770 $datadir/users/$adminuser/prasi.svc`;
open(IN,"> $datadir/users/$adminuser/name") || die "could not open $datadir/users/$adminuser/name";
print IN "Prasi Administrator";
print "Configured admin details for prasi service (1 of 2)...\n";
print `chmod 770 $datadir/users/$adminuser/name`;
open(IN,"> $datadir/users/$adminuser/email") || die "could not open $datadir/users/$adminuser/email";
print IN "$adminemail";
print "Configured admin details for prasi service (2 of 2)...\n";
print `chmod 770 $datadir/users/$adminuser/email`;
}
# UPGRADE BLOCK END

# DEMO USER START
$pw = main::md5_hex("demo");
print `mkdir $datadir/users/demo`;
print `chmod 770 $datadir/users/demo/`;
open(WHERE,"> $datadir/users/demo/password") || die "could not save demo-user password!";
print WHERE $pw;
print "Saved demo-user password...\n";
close(WHERE);
print `chmod 770 $datadir/users/demo/password`;
open(IN,"> $datadir/users/demo/prasi.svc") || die "could not open $datadir/users/demo/prasi.svc";
print IN " ";
print "Configured demo-user for prasi service...\n";
print `chmod 770 $datadir/users/demo/prasi.svc`;
open(IN,"> $datadir/users/demo/name") || die "could not open $datadir/users/demo/name";
print IN "Demonstration User";
print "Configured demo-user details for prasi service (1 of 2)...\n";
print `chmod 770 $datadir/users/demo/name`;
open(IN,"> $datadir/users/demo/email") || die "could not open $datadir/users/demo/email";
print IN "$adminemail";
print "Configured demo-user details for prasi service (2 of 2)...\n";
print `chmod 770 $datadir/users/demo/email`;
#DEMO USER END

open(IN,"> $datadir/prasi_sessions.dat") || die "could not create $datadir/prasi_sessions.dat";
print IN " ";
print "Created Sessions File...\n";
close(IN);  # what about permissions???

close(IN);
print "About to secure your installation...\n";
print `unlink ./prasi_installer.cgi`;
print `unlink $installdir/prasi_installer.cgi`;
print " (done)\n";

print "\n\nFinished, at last.\n\n";

print "</pre></div>";
 if(-e "../index.cgi") {
# send to wefis: prasi root, domain name, ....
 print <<"PERLMAIN";
Your Prasi system is now installed and configured. 
<b>Copy and save the text in the blue box in case you need to troubleshoot a faulty installation later!</b>
<br><br>
You should now <a href="../index.cgi?domain=$server&prasiroot=$installdir&prasinameroot=$webdir&installtype=$installtype&step=3">return to the Wefis installer</a> and finish installing Wefis.
PERLMAIN
 } else {
 print <<"PERLMAIN";
Your Prasi system is now installed and configured. 
<b>Copy and save the text in the blue box in case you need to troubleshoot a faulty installation later!</b>
<br><br>
You should now <a href="${webdir}/login.cgi?return=manage.cgi">log in to the control panel</a> and start playing with Prasi.
PERLMAIN
}
}
if($step eq "4") {
 print <<"PERLMAIN";
Where are you coming from? There is no step 4.
PERLMAIN
}
 
print <<"PERLFOOT";
<center>
<br><br>
<div class="prasi" id ="prasi">
Version $installversion -- http://prasi.sourceforge.net
</div>
</center>
PERLFOOT

exit;



######################################################################################



sub write_prasipl {
print WHERE <<'PERLFOO';

use CGI::Carp "fatalsToBrowser";
use CGI;

package main;  # fully scoped
sub prasi_login {
 (my $a, my $b) = @_;
 my $ret = PRASI::prasi_login($a,$b);
 return $ret;
}
sub prasi_data {
 (my $a, my $b) = @_;
 my @ret = PRASI::prasi_data($a,$b);
 return @ret;
}
sub prasi_save {
 (my $a, my $b, my $c, my $d) = @_;
 PRASI::prasi_save($a,$b,$c,$d);
 return "";
}
sub prasi_userlist {
 (my $a) = @_;
 my $ret = PRASI::prasi_userlist($a);
 return $ret;
}
package PRASI;

my $f = new CGI;

my $plog = "<script>p=escape(window.location);window.location='${PRASI::purl}login.cgi?action=miniform&return='+p;</script>";
$plog .= "<noscript>$PRASI::lang::msg117a <a href=\"$PRASI::purl\">Prasi</a> $PRASI::lang::msg117b</noscript>";

my $perr = "<script>p=escape(window.location);window.location='${PRASI::purl}login.cgi?action=error&return='+p;</script>";
$perr .= "<noscript>$PRASI::lang::msg118a <a href=\"$PRASI::purl\">Prasi</a> $PRASI::lang::msg118b</noscript>";

my $passexp = "<script>p=escape(window.location);window.location='${PRASI::purl}login.cgi?action=passexp&return='+p;</script>";
$passexp .= "<noscript>$PRASI::lang::msg119 <a href=\"$PRASI::purl\">Prasi</a>.</noscript>";

my $badip = "<script>p=escape(window.location);window.location='${PRASI::purl}login.cgi?action=badip&return='+p;</script>";
$badip .= "<noscript>$PRASI::lang::msg120 <a href=\"$PRASI::purl\">Prasi</a>.</noscript>";

my $badipshadow = "<script>p=escape(window.location);window.location='${PRASI::purl}login.cgi?action=logout&return='+p;</script>";
$badipshadow .= "<noscript>$PRASI::lang::msg120 <a href=\"$PRASI::purl\">Prasi</a>.</noscript>";

$prasi_session_expires = 0;  # We need this as a true global! Sorry.

sub prasi_login {
(my $sn,my $stop)=@_;
my $key = $f->cookie($PRASI::pcook);
if($key eq "") { return "" unless $stop; print "$plog"; exit; }
my $u=get_globalprasi_user($key);
if($u eq "") { return "" unless $stop; print "$plog"; exit; }
if(-e "$PRASI::datatree/users/$u/language") {
 open(IN,"<$PRASI::datatree/users/$u/language");
 my ($ulang) = <IN>;
 close(IN);
 if(-e "$PRASI::langpath/lang-$ulang.pl") {
  require "$PRASI::langpath/lang-$ulang.pl";
 }
}
unless(-e "$PRASI::datatree/users/$u/$sn.svc") { return "" unless $stop; print "$perr"; exit; }
unless (check_service_requires($u,$sn)) {
 my $chreq = "<script>p=escape(window.location);window.location='${PRASI::purl}login.cgi?action=chk&requires=$sn&return='+p;</script>";
 $chreq .= "<noscript>$PRASI::lang::msg121a '$sn'$PRASI::lang::msg121b <a href=\"${PRASI::purl}login.cgi?action=chk&requires=$sn\">$PRASI::lang::msg121c</a>.</noscript>";
 print "$chreq";
 exit;
}
unless(verify_ip($u)) {print "$badipshadow" unless $stop; print "$badip"; exit;}
if(time() > $prasi_session_expires) {print "$passexp";exit;}
return $u;
}

sub prasi_data {
(my $u,my $name)=@_;
$u=~s/[^a-zA-Z]/_/g;
$name=~s/[^a-zA-Z01-9]/_/g;
my $file = "$PRASI::datatree/users/$u/$name";
open(IN,"< $file") or return "";
my @data=<IN>;
close(IN);
return @data;
}

sub prasi_save { # allowed to be 'slower'
(my $u,my $name,my $data,my $svn)=@_;
$u=~s/[^a-zA-Z]/_/g;
$name=~s/[^a-zA-Z01-9]/_/g;
$svn=~s/[^a-zA-Z01-9]/_/g;
my $file = "$PRASI::datatree/users/$u/$name";
if(!$name) {die("$PRASI::lang::msg122 '$name'.");}
if(!$u) {die("$PRASI::lang::msg123 '$u'.");}
if(!$svn) {die("$PRASI::lang::msg124 '$svn'.");}
if($name =~ /${svn}/) {
 if(!$data) {
  # delete the now-empty data-file
  unlink "$file";
 } else {
  open(IN,"> $file") or die ("$PRASI::lang::msg125 '$name'.");
  print IN "$data";
  close(IN);
  chmod oct("0770"), "$file"; # might not exist yet
 }
} else {
die ("$PRASI::lang::msg126a ($svn) $PRASI::lang::msg126b ($name). $PRASI::lang::msg126c");
}
}

sub prasi_userlist {
 (my $svc) =@_;
 $svc =~ s/[^a-zA-Z01-9]/_/gi;
 my $list = "";
 my @ufiles = "";
 if (opendir(DIR,"$PRASI::datatree/users") == 1) {
      @ufiles = readdir(DIR);
      closedir(DIR);
   }
   else {
    die("$PRASI::lang::msg71");
   }
   my @utfiles = sort @ufiles;
   my $ufitem = "";
   foreach $ufitem (@utfiles) {
      my $ufitem_pathname = "$PRASI::datatree/users" . "/" . "$ufitem";
      if (-e $ufitem_pathname) {
         if (-d $ufitem_pathname) {
          if($ufitem eq ".") {next;}
          if($ufitem eq "..") {next;}
		  if(($svc eq "") or 
		   (-e "$PRASI::datatree/users/$ufitem/$svc.svc") or
		   (-e "$PRASI::datatree/users/$ufitem/$svc.rsvc")
		   ) {$list .= "$ufitem\n";}
		  }
	    }
	}
 return "$list";
}

sub get_globalprasi_user {
 (my $sess) = @_;
 open(IN,"< $PRASI::datatree/prasi_sessions.dat") or die "$PRASI::lang::msg127";
 my @li = <IN>;
 close(IN);
 my $ll = "";
 foreach $ll (@li) {if ($ll =~ /${sess}:(.*):(.*)/) {$prasi_session_expires=$2;return $1;}}
 return "";
}

sub verify_ip {
(my $u)=@_;
open(IN,"< $PRASI::datatree/users/$u/ip") or die "$PRASI::lang::msg128";
my @li = <IN>;
close(IN);
(my $shouldbe)=@li;
chomp($shouldbe);
if ($shouldbe ne $ENV{'REMOTE_ADDR'}) {return 0;}
return 1;
}

sub check_service_requires {
(my $u,my $sn) = @_;
my $path = "$PRASI::datatree/services/$sn.cfg";
open(IN,$path) or die "$PRASI::lang::msg129 '$sn'";
my @lines = <IN>;
close(IN);
my $line = "";
foreach $line (@lines) {if($line =~ /require:(.*)/) {
 (my $con) = prasi_data($u,$1); chomp($con); if($con eq "") { return 0;}
 }}
return 1;
}

return 1;

PERLFOO
}


######################################################################################
